/*
  CPP_CONTEST=2013
  CPP_PROBLEM=G
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 1
*/

// 3

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>

void escribir(int nivel,int nw,int nt,int *s,int *asig,int Bact)
{
  int i;

  printf("  en nivel: %d\n",nivel);
  printf("  solucion con beneficio %d: ",Bact);
  for(i=0;i<nt;i++)
    printf("%d , ",s[i]);
  printf("\n");
  printf("  asignados: ");
  for(i=0;i<nw;i++)
    printf("%d , ",asig[i]);
  printf("\n");
  scanf("%d\n",&i);
}

int solution(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig)
{
//solution if in the last level and restrictions are fulfilled
  return( (nivel==nt-1) && (b[s[nivel]*nt+nivel]!=0) && (asig[s[nivel]]<=c[s[nivel]]) );
}

int value(int nw,int nt,int *b,int *s)
{
  int v=0,i;

  for(i=0;i<nt;i++)
    v+=b[s[i]*nt+i];
  return v;
}

int criterio(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig,int Bact,int *Bmax,int VOA)
{
//sons can be generated if not in the last level and restrictions are fulfilled
  return( (nivel!=nt-1) && (b[s[nivel]*nt+nivel]!=0) && (asig[s[nivel]]<=c[s[nivel]]) && (Bact+Bmax[nivel+1]>VOA));
}

int more(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig)
{
//if not all the possible assignations of workers to the tasks have been evaluated
  return( s[nivel]!=nw-1 );
}

void  generate(int nivel,int nw,int nt,int *b,int *c,int *s,int *asig,int *Bact)
{
//if not the first son, decrease the number of asignations to the worker
  if(s[nivel]!=-1)
  {
    asig[s[nivel]]--;
    *Bact-=b[s[nivel]*nt+nivel];
  }
//assign next worker to the task
  s[nivel]++;
  asig[s[nivel]]++;
  *Bact+=b[s[nivel]*nt+nivel];
}

void  retrocede(int *nivel,int nw,int nt,int *b,int *c,int *s,int *asig,int *Bact)
{
  *Bact-=b[s[*nivel]*nt+*nivel];
  asig[s[*nivel]]--;
  s[*nivel]=-1;
  (*nivel)--;
}

int sec(int nw,int nt,int *b,int *c,int node,int np)
{
  int i,j,max; //auxiliar
  int VOA=0; //if finally has value 0, no solution can be found
  int Bact=0; //the benefit with the solution in the node
  int *sol; //contains the assignation of workers to the tasks
  int *asig; //number of tasks assigned to each worker
  int nivel=0; //nivel in the backtracking tree
  int *Bmax; //stores the maximum beneficit from one task to the end

  sol=(int *) malloc(sizeof(int)*nt);
  asig=(int *) malloc(sizeof(int)*nw);
  Bmax=(int *) malloc(sizeof(int)*nt);
//Initially no workers are assigned to the tasks
  for(i=0;i<nt;i++)
    sol[i]=-1;
  for(i=0;i<nw;i++)
    asig[i]=0;
  for(i=0;i<nt;i++)
  {
    max=0;
    for(j=0;j<nw;j++)
    {
       if(b[j*nt+i]>max)
         max=b[j*nt+i];
    }
    Bmax[i]=max;
  }
  for(i=nt-2;i>=0;i--)
    Bmax[i]=Bmax[i]+Bmax[i+1];
#ifdef DEBUG
      printf("After initialization:\n");
      escribir(nivel,nw,nt,sol,asig,Bact);
#endif

  do{
      generate(nivel,nw,nt,b,c,sol,asig,&Bact);
#ifdef DEBUG
      printf("After generation:\n");
      escribir(nivel,nw,nt,sol,asig,Bact);
#endif
      if(solution(nivel,nw,nt,b,c,sol,asig))
      {
#ifdef SOLUTION
      printf("Is solution:\n");
      escribir(nivel,nw,nt,sol,asig,Bact);
#endif
         if(Bact>VOA)
         {
            VOA=Bact;
#ifdef VIEWVOA
      printf("Is solution, with value: %d\n",Bact);
      escribir(nivel,nw,nt,sol,asig,Bact);
      printf("  and updates VOA to: %d\n",VOA);
#endif
         }
      }
      if(criterio(nivel,nw,nt,b,c,sol,asig,Bact,Bmax,VOA))
      {
#ifdef DEBUG
      printf("Criterium fulfilled, so new node generated\n");
#endif
         nivel++;
      }
      else
      {
          while((nivel!=-1) && !more(nivel,nw,nt,b,c,sol,asig))
          {
             retrocede(&nivel,nw,nt,b,c,sol,asig,&Bact);
#ifdef DEBUG
      printf("After backtracking:\n");
      escribir(nivel,nw,nt,sol,asig,Bact);
#endif
          }
      }
  }while(nivel!=-1); //finishes when returns to the root 
  free(sol);
  free(asig);
  free(Bmax);
  return VOA;
}
